#include <cstdio>
#include <cmath>
#define MIN(a,b) (a)<(b)?(a):(b)
#define MAX(a,b) (a)>(b)?(a):(b)
#define maxN 2510

double a,b,c,q;
int n;
double list[maxN][2];

void input()
{
	int i;
	scanf("%lf%lf%lf",&a,&b,&c);
	scanf("%d",&n);
	for (i=0;i<n;++i) scanf("%lf%lf",&list[i][0],&list[i][1]);
}

char test(double c1)
{
	int i;
	double l=-100000.0,r=100000.0,q1,q2,D;
	for (i=0;i<n;++i) {
		D = b*b-4.0*a*(c+c1-list[i][1]);
		if (D < 0.0) return 0;
		D = sqrt(D);
		q1 = (-b-D)/(2.0*a);
		q2 = (-b+D)/(2.0*a);
		if (q1>q2) {D=q1;q1=q2;q2=D;}
		q1-=list[i][0]; q2-=list[i][0];
		//printf("q1=%lf\nq2=%lf\n",q1,q2);
		if (q1 > r) return 0;
		if (q2 < l) return 0;
		l = MAX(l,q1);
		r = MIN(r,q2);
		}
	q = (l+r)/2.0;
	if (r>=l) return 1;
	return 0;
}

void solve()
{
	double l=-15000.0,r=15000.0,m,t;
	int br=1024;
	while (br>0) {
		m = (l+r)/2.0;
		if (test(m)) r=m;
		else l=m;
		--br;
		}
	m = r;
	test(m);
	t = -b/(2.0*a);
	printf("%lf %lf\n",t-q,a*t*t+b*t+c+m);
}

int main()
{
	input();
	solve();
	return 0;
}
