#include<cstdio>
#include<cmath>

double a,b,c;
int n;
struct pnt{double x,y;} pts[52];

double otmx, otmy, vx, vy;

#define MIN(a,b) (a<b)?(a):(b)
#define MAX(a,b) (a>b)?(a):(b)
bool in(pnt&p) {
  double d=b*b-4*a*(c+otmy-p.y);
  if(d<0) {return false;}
  d=sqrt(d);
  double k1=(-b-d)/(2*a),k2=(-b+d)/(2*a);
  if( MIN(k1,k2)<=(p.x+otmx) && (p.x+otmx)<=MAX(k1,k2) ) return true;
  return false;
}

bool check() {
  for(int i=0;i<n;++i) if(!in(pts[i])) {return false;}
  return true;
}

void getotmy() {
  double down=-10000,up=10000,m,old;
  for(int i=0;i<10000;++i) {
    m=(up+down)/2.0;
    old=otmy;
    otmy=m;
    if(!check()) {
      down=m;
      otmy=old;	
    }
    else {
      up=m;
      otmy=m;
    }
  }
}

int main() {
  scanf("%lf%lf%lf",&a,&b,&c);
  scanf("%d",&n);
  double minx=1000000,maxx=0;
  for(int i=0;i<n;++i) {
    scanf("%lf%lf",&pts[i].x,&pts[i].y);
    if(minx>pts[i].x)minx=pts[i].x;
    if(maxx<pts[i].x)maxx=pts[i].x;
  }
  
  vx=-b/(2*a); vy=a*vx*vx+b*vx+c;
  otmx=(maxx+minx)/2.0-vx;
  getotmy();
  
  printf("%lf %lf\n",vx+otmx,vy+otmy);
  return 0;
}