#include<iostream>
#include<vector>
#include<cmath>
#define EPS 1e-9

using namespace std;

typedef struct point
{
   double x,y;

void READ()
{
 scanf("%lf%lf",&x,&y);
}
};


typedef struct el
{
    double minx,maxx;
    double y;
};

    el G[2500];
    int gn;

    point p[2600];
    int n;

    double A,B,C,V;

el ttt;

el makeel(double minx,double maxx,double y)
{
   ttt.minx=minx;
   ttt.maxx=maxx;
   ttt.y=y;
return ttt;
}
bool cmp(point p1,point p2)
{
    return p1.y<p2.y;
}
void INIT()
{
    double o;
    o=-1*B/(2*A);

    V=o*o*A+o*B+C;
}
double getx(double len)
{
    double aa,bb,cc;
    aa=A;
    bb=B;
    cc=C-V+len;

    double x1,x2,Det=bb*bb-4*aa*cc;
    x1=(-1*bb+sqrt(Det))/(2*aa);
    x2=(-1*bb-sqrt(Det))/(2*aa);
  return fabs(x1-x2);
}
bool check(double x,double y)
{
    int i;
    double len;

    for(i=0;i<gn;i++)
    {
      len=getx(y-G[i].y);
      if(x-len/2>G[i].minx)return false;
      if(x+len/2<G[i].maxx)return false;
    }
return true;
}

void PRINT()
{
   cout<<"A, B i C "<<A<<" "<<B<<" "<<C<<"\n";
   cout<<"v1rha na parabolata e na "<<(-1*B)/(2*A)<<" "<<V<<"\n";
   printf("len za 2 e %lf\n",getx(2));
}
int main()
{
    scanf("%lf%lf%lf",&A,&B,&C);
    scanf("%d",&n);
    int i,l,j;
    for(i=0;i<n;i++)p[i].READ();

    INIT();
   double Xans=10000,Yans=10000,Xtmp;

    double left=-100000;
    double right=1e30;
    double mid,len;
    double minx=1000000,maxx=-100000;

    //PRINT();
    sort(p,p+n,cmp);

    p[n].y=534671;

    el to;

    for(i=0;i<n;i++)
    if(p[i].y!=p[i+1].y)
    {
     minx=min(minx,p[i].x);
     maxx=max(maxx,p[i].x);

     G[gn++]=makeel(minx,maxx,p[i].y);

     minx=1000000;
     maxx=-100000;

     left=max(left,p[i].y);
    }
    else
    {
     minx=min(minx,p[i].x);
     maxx=max(maxx,p[i].x);
    }

    bool fl=0;

    for(i=0;i<1000;i++)
    {
     fl=0;
     mid=(left+right)/2;
     //cout<<"za "<<mid<<"\n";
     for(l=0;l<gn;l++)
     {
      len=getx(mid-G[l].y);
      //printf("%lf e za %lf\n",len,mid-G[l].y);
      if(check(G[l].minx+len/2,mid)){Xtmp=G[l].minx+len/2;fl=1;break;}
      if(check(G[l].maxx-len/2,mid)){Xtmp=G[l].maxx-len/2;fl=1;break;}
      if(check(G[l].minx,mid)){Xtmp=G[l].minx;fl=1;break;}
      if(check(G[l].maxx,mid)){Xtmp=G[l].maxx;fl=1;break;}
     }
     if(fl==1)
     {
      right=mid;
      Yans=mid;
      Xans=Xtmp;
     }
     else
     {
      left=mid;
     }
     //printf("eendd\n");
    }
    printf("%lf %lf\n",Xans,Yans);
return 0;
}
