#include <iostream>
using namespace std;

const int max_n = 2505;
double a;
int px[max_n], py[max_n], ps[max_n], pc[max_n], pcl;

struct cmpls{
    bool operator()(const int& a, const int& b){
        return px[a] < px[b] || ((px[a] == px[b]) && (py[a] < py[b]));
    }   
};

cmpls cl;

#define D (double)
#define F(Q,a,b,c) ((a)*(Q)*(Q) + (b)*(Q) + (c))
#define left(a, b, c) (((px[b] - px[a])*(py[c] - py[a]) - (px[c] - px[a])*(py[b] - py[a])) > 0)

double bp, cp;

bool check(int i, int j){
    int k;
    //if the parabola through i,j is usable
    if(i == j){
        bp = - 2.0*a*D(px[pc[i]]);
        cp = D(py[pc[i]]) - (D(a*px[pc[i]]*px[pc[i]] + bp*px[pc[i]]));
    }else{
        bp = D(py[pc[i]] - py[pc[j]])/D(px[pc[i]] - px[pc[j]]) - D(a*(px[pc[i]] + px[pc[j]]));
        cp = D(py[pc[i]]) - D(a*px[pc[i]]*px[pc[i]] + bp*D(px[pc[i]]));
    }
    double r;
    for(k = 0; k < pcl; k++){
        r = F(px[pc[k]], a, bp, cp);
        if(r < py[pc[k]]) return false;
    }
    return true;
}

int main(){
    int i, j, k, n;
    double b, c, X, Y;
    cin >> a >> b >> c >> n;
    for(i = 0; i < n; i++){
        scanf("%d%d", &px[i], &py[i]);
        ps[i] = i;
    }
    
    if(n == 1){
        cout << px[0] << ' ' << py[0] <<   endl;
        return 0;    
    }
    if(n == 2){
        if(px[0] == px[1]){
            if(py[0] < py[1]){
                cout << px[1] << ' ' << py[1] << endl;
            }else{
                cout << px[0] << ' ' << py[0] << endl;    
            }    
        }else{
            bp = D(py[0] - py[1])/D(px[0]-px[1]) + D(a*(px[0] + px[1]));
            cp = D(px[0])*D(a*px[0] + bp);
            X = - bp/(2.0*a);
            Y = F(X, a, b, c);
            cout << X << ' ' << Y << endl;
        }
        return 0;
    }
    
    sort(ps, ps + n, cl);
    
    pc[0] = ps[0];
    pc[1] = ps[1];
    pcl = 2;
    for(i = 2; i < n; i++){
        pc[pcl++] = ps[i];
        while(pcl > 2 && left(pc[pcl-3], pc[pcl-2], pc[pcl-1])){
            pc[pcl - 2] = pc[pcl - 1];
            pcl --;
        }
    }
    
    
    
    /*
    int st = 0;
    while(st < pcl-1 && px[pc[st]] == px[pc[st+1]]) st++;
    if(st == pcl-1){
        cout << px[pc[st]] << ' ' << py[pc[st]] << endl;
        return 0;
    }
    
    
    if(pcl - st < 100){
        for(i = st; i < pcl; i++)
        for(j = i; j < pcl; j++){
                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                                   
        }
    }
    
    for(i = st; i < pcl; i++){
        for(j = i; j < pcl; j++)    
    }
    */
    
    double ym, xm, tx, ty;
    bool fl = false;
    if(pcl < 350){
    for(i = 0; i < pcl; i++)
    for(j = i; j < pcl; j++)
        if(px[px[i]] != px[pc[j]] && check(i, j)){
            if(!fl){
                fl = true;
                xm = -bp/(2.0*a);
                ym = F(xm, a, bp, cp);    
            }else{
                tx = -bp/(2.0*a);
                ty = F(tx, a, bp, cp);
                if(ty < ym){
                    ym = ty;
                    xm = tx;    
                }
            }
        }
    }else{
        ym = py[pc[0]];
        for(i = 0; i < pcl; i++)
        if(ym < py[pc[i]]) ym = py[pc[i]];
        
        bp = - D(a*(px[pc[0]] + px[pc[pcl-1]]));
        cp = ym - D(a*px[pc[0]]*px[pc[0]] + bp*D(px[pc[0]]));
        xm = -bp/(2.0*a);
        ym = F(xm, a, bp, cp);
        
    }
    
    
    
    
    cout << xm << ' ' << ym << endl;
    return 0;    
}
