
#include <set>
#include <vector>
#include <iostream>
#include <algorithm>
using namespace std;

const int MAXN = 1005;
const int MAXK = 1005;
const int INF = 536870912;

#define remin(a, b) (a = min(a, b))

int dp[MAXN][MAXK][5];

int N, K, B;
bool on[MAXN][2];
set <int> up, down, all;
vector <int> xs;

int ALL;

void read() {
    scanf("%d %d %d", &N, &K, &B);
    for (int i = 0; i < N; ++i) {
        int y, x;
        scanf("%d %d", &y, &x);
        if (y == 1) {
            up.insert(x);
        } else {
            down.insert(x);
        }
        all.insert(x);
    }
}

int rec(int pos, int am, int set) {
    if (am < 0)
        return INF;
    if (pos == ALL)
        return 0;
    int &sol = dp[pos][am][(set == 7 ? 4 : set)];
    if (sol >= 0)
        return sol;
    sol = INF;
    if ((set & 1) == 0)
        remin(sol, rec(pos, am - 1, set | 1) + 1);
    if ((set & 2) == 0)
        remin(sol, rec(pos, am - 1, set | 2) + 1);
    if ((set & 3) == 0) {
        remin(sol, rec(pos, am - 2, set | 3) + 2);
        remin(sol, rec(pos, am - 1, 7) + 2);
    }
    bool can = true;
    if (on[pos][0] && ((set & 1) == 0)) can = false;
    if (on[pos][1] && ((set & 2) == 0)) can = false;
    if (can) {
        if (set == 7) {
            remin(sol, rec(pos + 1, am, 0));
            remin(sol, rec(pos + 1, am, 7) + 2 * (xs[pos + 1] - xs[pos]));
        } else {
            for (int nset = 0; nset < 4; ++nset)
                if ((set & nset) == nset) {
                    int cost = 0;
                    for (int j = 0; j < 2; ++j)
                        if (((nset >> j) & 1) > 0) {
                            cost += xs[pos + 1] - xs[pos];
                        }
                    remin(sol, rec(pos + 1, am, nset) + cost);
                }
        }
    }
    return sol;
}

void solve() {
    xs = vector <int>(all.begin(), all.end());
    vector <int> a(up.begin(), up.end());
    vector <int> b(down.begin(), down.end());
    for (int i = 0; i < (int) a.size(); ++i)
        on[lower_bound(xs.begin(), xs.end(), a[i]) - xs.begin()][0] = true;
    for (int i = 0; i < (int) b.size(); ++i)
        on[lower_bound(xs.begin(), xs.end(), b[i]) - xs.begin()][1] = true;
    
    ALL = xs.size();
    xs.push_back(16000000);
    memset(dp, -1, sizeof(dp));
    printf("%d\n", rec(0, K, 0));
    /*
    for (int i = 0; i < (int) xs.size(); ++i)
        cout << on[i][0];
    cout << endl;
        for (int i = 0; i < (int) xs.size(); ++i)
        cout << on[i][1];
    cout << endl;*/
}

int main() {
    read();
    solve();
    return 0;
}
